#require "str";;
#directory "..";;
#load "netstring.cma";;

open Mimestring;;

(**********************************************************************)
(* scan_structured_value                                              *)
(**********************************************************************)

let t001() =
  let r = scan_structured_value "user@domain.com" [ '@'; '.' ] [] in
  r = [ Atom "user"; Special '@'; Atom "domain"; Special '.'; Atom "com" ]
;;


let t002() =
  let r = scan_structured_value "user @ domain . com" [ '@'; '.' ]  [] in
  r = [ Atom "user"; Special '@'; Atom "domain"; Special '.'; Atom "com" ]
;;


let t003() =
  let r = scan_structured_value "user(Do you know him?)@domain.com" [ '@'; '.' ]
 []  in
  r = [ Atom "user"; Special '@'; Atom "domain"; Special '.'; Atom "com" ]
;;


let t004() =
  let r = scan_structured_value "user @ domain . com" [ '@'; '.'; ' ' ] []  in
  r = [ Atom "user"; Special ' '; Special '@'; Special ' '; Atom "domain";
	Special ' '; Special '.'; Special ' '; Atom "com" ]
;;


let t005() =
  let r = scan_structured_value "user(Do you know him?)@domain.com"
	                        ['@'; '.'; '(']  [] in
  r = [ Atom "user"; Special '('; Atom "Do"; Atom "you"; Atom "know";
	Atom "him?)"; Special '@'; Atom "domain"; Special '.'; Atom "com" ]
;;


let t006() =
  let r = scan_structured_value "\"My.name\"@domain.com" [ '@'; '.' ]  [] in
  r = [ QString "My.name"; Special '@'; Atom "domain"; Special '.';
	Atom "com" ]
;;


let t007() =
  let r = scan_structured_value "\"\\\"()@. \"@domain.com" [ '@'; '.' ]  [] in
  r = [ QString "\"()@. "; Special '@'; Atom "domain"; Special '.';
	Atom "com" ]
;;


let t008() =
  let r = scan_structured_value "a(b(c(d)e)f)g" [] [] in
  r = [ Atom "a"; Atom "g" ]
;;


let t009() =
  let r = scan_structured_value "a(b(c(d)e)f" [] [] in
  r = [ Atom "a" ]
;;


let t010() =
  let r = scan_structured_value "a(b\\(c\\(d\\)e)f" [] [] in
  r = [ Atom "a"; Atom "f" ]
;;


let t011() =
  let r = scan_structured_value "a(b(c(d)e)f\\" [] [] in
  r = [ Atom "a" ]
;;


let t012() =
  let r = scan_structured_value "\"abc" [] [] in
  r = [ QString "abc" ]
;;


let t013() =
  let r = scan_structured_value "\"abc\\" [] [] in
  r = [ QString "abc\\" ]
;;

(**********************************************************************)

let test f n =
  if f() then
    print_endline ("Test " ^ n ^ " ok")
  else
    print_endline ("Test " ^ n ^ " FAILED!!!!");
  flush stdout
;;

test t001 "001";;
test t002 "002";;
test t003 "003";;
test t004 "004";;
test t005 "005";;
test t006 "006";;
test t007 "007";;
test t008 "008";;
test t009 "009";;
test t010 "010";;
test t011 "011";;
test t012 "012";;
test t013 "013";;

